#pragma once
#include "DirectXFramework.h"

struct CBUFFER
{
	XMMATRIX    completeTransformation;
	XMMATRIX	worldTransformation;
	XMFLOAT4	cameraPosition;
	XMVECTOR    lightVector;
	XMFLOAT4    lightColor;
	XMFLOAT4    ambientColor;
	XMFLOAT4    diffuseCoefficient;
	XMFLOAT4	specularCoefficient;
	float		shininess;
	float		opacity;
	float       padding[2];
};

struct TCBUFFER
{
	XMMATRIX    completeTransformation;
	XMMATRIX	worldTransformation;
	XMFLOAT4	cameraPosition;
	XMVECTOR    lightVector;
	XMFLOAT4    lightColor;
	XMFLOAT4    ambientColor;
	XMFLOAT4    diffuseCoefficient;
	XMFLOAT4	specularCoefficient;
	float		shininess;
	float		opacity;
	float waterHeight;
	float waterShininess;
	XMFLOAT4 waterColor;
	float padding[4];
};

namespace SharedMethods
{
	XMMATRIX RotateFromPoint(float x, float y, float z, XMMATRIX rotationMatrix);

	float RGBValueToIntensity(int value);
	float Lerp(int a, int b, int p);
	float Lerp(float a, float b, float p);

	float GenerateRandomIntensity(float min, float max);
	float GenerateRandomUV(int min, int max);
};

